
package de.ivu.elect.business.personenpruefung.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.personenpruefung.entity.PersonenKonflikt;

// abgeleitete Klasse mit "@javax.ejb.Stateless" annotieren!
public abstract class AbstractPersonenKonfliktEdit {

  @Inject
  protected PersonenKonfliktDAO dao;

  @Inject
  protected PersonenKonfliktExtendedDAO extendedDao;

  public void delete(PersonenKonflikt entity) {
    dao.remove(getAttachedEntity(entity));
  }

  public void save(PersonenKonflikt entity) {
    validate(entity);

    flushToSave();
  }

  protected void validate(PersonenKonflikt entity) {
    // Do nothing by default.
  }

  protected void flushToSave() {
    if(usesMixedTransactionalContexts()) {
        extendedDao.flushNewTransaction();
    } else {
        extendedDao.flush();
    }
  }

  // ELECT-945
  protected boolean usesMixedTransactionalContexts() {
    return false;
  }

  protected PersonenKonflikt getAttachedEntity(PersonenKonflikt entity) {
    return dao.findByPrimaryKey(entity.getPk());
  }

  // Cf. ELECT-3187 (Änderungen an Entität werden nicht gespeichert)
  protected PersonenKonflikt getAttachedAndRefreshedEntity(PersonenKonflikt entity) {
    return dao.refresh(entity);
  }
}
